<?php
// +------------------------------------------------------------------------+
// | PHP Melody version 1.6.7 ( www.phpsugar.com )
// +------------------------------------------------------------------------+
// | PHP Melody IS NOT FREE SOFTWARE
// | If you have downloaded this software from a website other
// | than www.phpsugar.com or if you have otherwise received
// | this software from someone who is not a representative of
// | this site you are involved in an illegal activity.
// | ---
// | In such case, please contact us at: support@phpsugar.com.
// +------------------------------------------------------------------------+
// | Developed by: phpSugar (www.phpsugar.com) / support@phpsugar.com
// | Copyright: (c) 2004-2011 PhpSugar.com. All rights reserved.
// +------------------------------------------------------------------------+

if(!defined('PHPMELODY'))
	die('Restricted Access!');

$mtvmusic_error_msg = '';

function get_info($url, $ignore_prefix = false)
{
	global $mtvmusic_error_msg;
	
	$video_data = array();
	$video_id	= '';
	$artist_uri	= '';
	$pieces		= array();
	$video_slug = '';

	if(strpos($url, 'mtvhive.com') !== false)
	{
		preg_match('/mtvhive\.com\/(.*?)\/videos\/(.*?)\/(.*)/', $url, $matches);
	}
	else
	{
		preg_match('/mtv\.com\/videos\/(.*?)\/(.*?)\/(.*?)\.jhtml/', $url, $matches);
	}
		
	$artist_uri	= str_replace('-', '_', $matches[1]);
	$video_id = $matches[2];
	$video_slug = $matches[3];
	
	if (strpos($artist_uri, 'artist/') !== false)
	{
		$artist_uri = str_replace('artist/', '', $artist_uri);
	}
	
	if($ignore_prefix === false)
	{
		$temp = explode("_", $artist_uri);
		if($temp[0] == 'a' || $temp[0] == 'the')
		{
			array_shift($temp);
			$artist_uri = implode('_', $temp);
		}
	}

	//$target_url  = 'http://api.mtvnservices.com/1/artist/';
	//$target_url .= $artist_uri .'/videos/?start-index=1&max-results=98';
	$target_url = 'http://www.mtvhive.com/artist/'. $artist_uri .'/videos/'. $video_id .'/'. $video_slug;

	$error = 0;
	if(function_exists('curl_init'))
	{
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $target_url);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7.5) Gecko/20041107 Firefox/1.0');
		$video_data = curl_exec($ch);
		$mtvmusic_error_msg = curl_error($ch);
		curl_close($ch);
		
		if($errormsg != '')
		{
			//echo $errormsg;
			return false;
		}
	}
	else if(ini_get('allow_url_fopen') == 1)
	{
		$video_data = @file_get_contents($target_url);
		if($video_data === false)
			$error = 1;
	}
	
	if( ! is_array($video_data))
	{
		$video_data = explode("\n", $video_data);
	}
	
	return $video_data;
}

function get_flv($video_data)
{	
	//return $video_data['URI'];
	return '';
}

function get_thumb_link($video_data) 
{
	//return $video_data['MEDIA:THUMBNAIL']['url'];
	return '';
}

function video_details($video_data, $url, &$info, $show_warnings = true) 
{
	$arr_length = count($video_data);
	for($i = 0; $i < $arr_length; $i++)
	{
		$video_data[$i] = str_replace( array("\n", "\t", "\r"), '', $video_data[$i]);
		// artist
		if ($info['artist'] == '')
		{
			if(preg_match('/artistName : "(.*?)"/', $video_data[$i], $matches) != 0)
			{
				$info['artist'] = $matches[1];
			}
		}
		// video title
		if ($info['video_title'] == '')
		{
			if(preg_match('/MTVM\.contextValues\.video\.title = "(.*?)"/', $video_data[$i], $matches) != 0)
			{
				$info['video_title'] = $matches[1];
			}
		}
		// video id
		if ($info['yt_id'] == '')
		{
			if(preg_match('/MTVM\.contextValues\.video\.videoId = "(.*?)"/', $video_data[$i], $matches) != 0)
			{
				$info['yt_id'] = $matches[1];
			}
		}
		
		// duration
		if ($info['yt_length'] == '')
		{
			if(preg_match('/MTVM\.contextValues\.video\.duration = "(.*?)"/', $video_data[$i], $matches) != 0)
			{
				$info['yt_length'] = $matches[1];
			}
		}
		
		// tags
		if ($info['tags'] == '')
		{
			if(preg_match('/MTVM\.contextValues\.video\.keywords = "(.*?)"/', $video_data[$i], $matches) != 0)
			{
				$info['tags'] = $matches[1];
			}
		}
		
		// description
		if ($info['description'] == '')
		{
			if(preg_match('/MTVM\.contextValues\.video\.description = "(.*?)"/', $video_data[$i], $matches) != 0)
			{
				$info['description'] = $matches[1];
			}
		}
		
		// image
		/*if ($info['yt_thumb'] == '')
		{
			if(preg_match('/url : "(.*?)"/', $video_data[$i], $matches) != 0)
			{
				$info['yt_thumb'] = $matches[1];
			}
		}*/
	}
	
	$info['direct'] = $url;
	
	//	thumbnail link
	//$info['yt_thumb'] = get_thumb_link($video_data);
	$info['yt_thumb'] = 'http://mtvhive.mtvnimages.com/uri/mgid:uma:video:mtvmusic.com:'. $info['yt_id'] .'?width=140&height=105';
	
	//$info['url_flv'] = get_flv($video_data);
	$info['url_flv'] = $info['direct'];
}

function download_thumb($thumbnail_link, $upload_path, $video_uniq_id) {
	
	$last_ch = substr($upload_path, strlen($upload_path)-1, strlen($upload_path));
	if($last_ch != "/")
		$upload_path .= "/"; 

	$ext = ".jpg";
	
	$thumb_name = $video_uniq_id . "-1" . $ext;
	
	if(is_file( $upload_path . $thumb_name )) {
		return FALSE;
	}
	
	$error = 0;

	if ( function_exists('curl_init') ) 
	{

		$ch = curl_init();
		$timeout = 0;
		curl_setopt ($ch, CURLOPT_URL, $thumbnail_link);
		curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
		
		// Getting binary data
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_BINARYTRANSFER, 1);
		
		$image = curl_exec($ch);
		curl_close($ch);
		
		//	create & save image;
		$img_res = @imagecreatefromstring($image);
		if($img_res === false)
			return FALSE;
		
		$img_width = imagesx($img_res);
		$img_height = imagesy($img_res);
		
		$resource = @imagecreatetruecolor($img_width, $img_height);
		
		if( function_exists('imageantialias'))
		{
			@imageantialias($resource, true); 
		}
		
		@imagecopyresampled($resource, $img_res, 0, 0, 0, 0, $img_width, $img_height, $img_width, $img_height);
		@imagedestroy($img_res);
	
		switch($ext)
		{
			case ".gif":
				//GIF
				@imagegif($resource, $upload_path . $thumb_name);
			break;
			case ".jpg":
				//JPG
				@imagejpeg($resource, $upload_path . $thumb_name);
			break;  
			case ".png":
				//PNG
				@imagepng($resource, $upload_path . $thumb_name);
			break;
		}
	}
	else if( ini_get('allow_url_fopen') == 1 )
	{
		// try copying it... if it fails, go to backup method.
		if(!copy($thumbnail_link, $upload_path . $thumb_name ))
		{
			//	create a new image
			list($img_width, $img_height, $img_type, $img_attr) = @getimagesize($thumbnail_link);

			$image = '';

			switch($img_type)
			{
				case 1:
					//GIF
					$image = imagecreatefromgif($thumbnail_link);
					$ext = ".gif";
				break;
				case 2:
					//JPG
					$image = imagecreatefromjpeg($thumbnail_link);
					$ext = ".jpg";
				break;  
				case 3:
					//PNG
					$image = imagecreatefrompng($thumbnail_link);
					$ext = ".png";
				break;
			}
			
			$resource = @imagecreatetruecolor($img_width, $img_height);
			if( function_exists('imageantialias'))
			{
				@imageantialias($resource, true); 
			}
			
			@imagecopyresampled($resource, $image, 0, 0, 0, 0, $img_width, $img_height, $img_width, $img_height);
			@imagedestroy($image);
		}
		
		$thumb_name = $video_uniq_id . "-1" . $ext;
		
		$img_type = 2;
		switch($img_type)
		{
			default:
			case 1:
				//GIF
				@imagegif($resource, $upload_path . $thumb_name);
			break;
			case 2:
				//JPG
				@imagejpeg($resource, $upload_path . $thumb_name);
			break;  
			case 3:
				//PNG
				@imagepng($resource, $upload_path . $thumb_name);
			break;
		}
		
		if($resource === '')
			$error = 1;
	} 

	return $upload_path . $thumb_name;
}

function do_main(&$video_details, $url, $show_warnings = true)
{
	global $mtvmusic_error_msg;
	
	//	$show_warnings is required when importing a batch of videos from YT or MTVMusic.
	$video_data = get_info($url);
	if($video_data != false)
	{
		video_details($video_data, $url, $video_details, $show_warnings);
	}
	else
	{
		if ($show_warnings && $mtvmusic_error_msg != '')
		{
			echo '<div class="info_msg_err">'. $mtvmusic_error_msg .'</div>';
		}
		$video_details = array();
	}
}

?>